Package org.apache.tomcat.util.buf

## Interface ByteChunk.ByteOutputChannel

Enclosing class:
  ByteChunk

    public static interface ByteChunk.ByteOutputChannel

When we need more space we'll either grow the buffer ( up to the limit ) or send it to a channel. Same as java.nio.channel.WritableByteChannel.

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `realWriteBytes​(byte[] buf, int off, int len)` Send the bytes ( usually the internal conversion buffer ).
`void` `realWriteBytes​(ByteBuffer from)` Send the bytes ( usually the internal conversion buffer ).

### Method Detail

#### realWriteBytes

    void realWriteBytes​(byte[] buf,
                        int off,
                        int len)
                 throws IOException

Send the bytes ( usually the internal conversion buffer ). Expect 8k output if the buffer is full.

Parameters:
  `buf` - bytes that will be written
  `off` - offset in the bytes array
  `len` - length that will be written
Throws:
  `IOException` - If an I/O occurs while writing the bytes

#### realWriteBytes

    void realWriteBytes​(ByteBuffer from)
                 throws IOException

Send the bytes ( usually the internal conversion buffer ). Expect 8k output if the buffer is full.

Parameters:
  `from` - bytes that will be written
Throws:
  `IOException` - If an I/O occurs while writing the bytes